import React, { FormEvent } from 'react';
export type ResponseResource<T = any> = {
    payloads?: T;
    error?: ErrorResource;
};
export type ErrorResource = {
    abstract?: string;
    title?: string;
    code?: number;
    messages?: (string | {
        [s: string]: any;
    })[] | {
        [s: string]: any;
    };
};
export type ErrorMessagesProps = {
    messages?: (string | {
        [s: string]: any;
    })[] | (string | {
        [s: string]: any;
    } | any);
};
export type FormWrapperProps = React.PropsWithChildren & {
    onSubmit: (e: FormEvent<HTMLFormElement>) => Promise<ResponseResource>;
    setButtonDisabled?: React.Dispatch<React.SetStateAction<boolean>>;
    success?: (payloads: object | any) => void;
    successMessage?: string;
    successMessageTimeout?: number;
    ErrorMessages?: (props: ErrorMessagesProps) => JSX.Element;
};
export default function FormWrapper(props: FormWrapperProps): JSX.Element;
export declare function ErrorMessages(props: ErrorMessagesProps & {
    ignoreObject?: boolean;
}): JSX.Element;
