import { j as jsxRuntimeExports } from "../../jsx-runtime-5a50c612.js";
import { createContext, useState, useEffect, useContext } from "react";
import { Form, Alert } from "react-bootstrap";
const FormContext = createContext({
  getError: () => void 0,
  changeError: () => {
  }
});
function useForm() {
  const [ErrorR, setError] = useState();
  function getError(key = void 0) {
    if (key === void 0)
      return ErrorR;
    if (ErrorR === void 0)
      return ErrorR;
    if (ErrorR[key])
      return ErrorR[key];
    throw new Error("Unexpected.");
  }
  function changeError(error = void 0) {
    setError(error === void 0 ? void 0 : { ...{}, ...error });
  }
  return {
    getError,
    changeError
  };
}
function FormWrapper(props) {
  const [Validated, setValidated] = useState(false);
  const [ButtonDisabled, setButtonDisabled] = useState(false);
  const [Success, setSuccess] = useState(false);
  const Error2 = useForm();
  useEffect(() => {
    if (props.setButtonDisabled)
      props.setButtonDisabled(ButtonDisabled);
  }, [ButtonDisabled]);
  async function onSubmit(e) {
    e.preventDefault();
    setButtonDisabled(true);
    Error2.changeError(void 0);
    if (!e.currentTarget.checkValidity()) {
      setValidated(true);
      setButtonDisabled(false);
      return;
    }
    setValidated(false);
    const response = await props.onSubmit(e);
    if (response.error) {
      Error2.changeError(response.error);
      setValidated(true);
    }
    if (!response.error) {
      setSuccess(true);
      setTimeout(() => {
        setSuccess(false);
      }, props.successMessageTimeout || 5e3);
    }
    if (response.payloads && props.success)
      props.success(response.payloads);
    setButtonDisabled(false);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(FormContext.Provider, { value: Error2, children: /* @__PURE__ */ jsxRuntimeExports.jsxs(Form, { noValidate: true, validated: Validated, onSubmit, children: [
    Error2.getError() && /* @__PURE__ */ jsxRuntimeExports.jsxs(Alert, { variant: "warning", children: [
      /* @__PURE__ */ jsxRuntimeExports.jsxs(Alert.Heading, { children: [
        Error2.getError("abstract") && /* @__PURE__ */ jsxRuntimeExports.jsxs("span", { children: [
          "[",
          Error2.getError("abstract"),
          "]"
        ] }),
        Error2.getError("title") && /* @__PURE__ */ jsxRuntimeExports.jsx("span", { children: Error2.getError("title") })
      ] }),
      Error2.getError("messages") && props.ErrorMessages ? /* @__PURE__ */ jsxRuntimeExports.jsx(props.ErrorMessages, { messages: Error2.getError("messages") }) : /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: Error2.getError("messages"), ignoreObject: true })
    ] }),
    Success && /* @__PURE__ */ jsxRuntimeExports.jsx(Alert, { variant: "success", children: props.successMessage || "処理に成功しました" }),
    props.children
  ] }) });
}
function ErrorMessages(props) {
  if (Array.isArray(props.messages))
    return /* @__PURE__ */ jsxRuntimeExports.jsx("ul", { children: props.messages.map(
      (message, idx) => /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: message }, `errorMessageArray-${idx}`)
    ) });
  if (typeof props.messages === "string" || props.messages instanceof String)
    return /* @__PURE__ */ jsxRuntimeExports.jsx("li", { children: props.messages });
  if (props.messages !== null && typeof props.messages === "object") {
    if (props.ignoreObject)
      return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
    return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, { children: Object.keys(props.messages).map(
      (key, idx) => /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: props.messages[key] }, `errorMessageObject-${idx}`)
    ) });
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
}
function InputWrapper(props) {
  const formContext = useContext(FormContext);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "mb-2", children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs(Form.Label, { children: [
      props.label,
      props.required && /* @__PURE__ */ jsxRuntimeExports.jsx("span", { className: "text-danger", children: "＊" })
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "ms-2", children: props.children }),
    props.name && formContext.getError("messages") && formContext.getError("messages")[props.name] && /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "text-danger ms-1", children: /* @__PURE__ */ jsxRuntimeExports.jsx(ErrorMessages, { messages: formContext.getError("messages")[props.name] }) })
  ] });
}
export {
  ErrorMessages,
  FormWrapper,
  InputWrapper
};
