import { j as jsxRuntimeExports } from "../jsx-runtime-5a50c612.js";
import { useState, useEffect } from "react";
import { Pagination, Breadcrumb, Modal } from "react-bootstrap";
function Anchor(props) {
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    "a",
    {
      ...props,
      className: (props.as === "button" ? `btn btn-${props.variant || "primary"} ` : "") + (props.className || "")
    }
  );
}
function Paginate(props) {
  function toPrev() {
    props.setPage(Math.max(props.meta.currentPage - 1, 1));
  }
  function toNext() {
    props.setPage(Math.min(props.meta.lastPage, props.meta.currentPage + 1));
  }
  function toFirst() {
    props.setPage(1);
  }
  function toLast() {
    props.setPage(props.meta.lastPage);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(Pagination, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.First, { onClick: toFirst, disabled: props.meta.currentPage === 1 }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Prev, { onClick: toPrev, disabled: props.meta.currentPage === 1 }),
    props.meta.currentPage !== 1 && /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
      props.meta.currentPage - 1 !== 1 && /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Ellipsis, {}),
      /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Item, { onClick: toPrev, children: props.meta.currentPage - 1 })
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Item, { active: true, children: props.meta.currentPage }),
    props.meta.currentPage !== props.meta.lastPage && /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Item, { onClick: toNext, children: props.meta.currentPage + 1 }),
      /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Ellipsis, {})
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Next, { onClick: toNext, disabled: props.meta.lastPage === props.meta.currentPage }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(Pagination.Last, { onClick: toLast, disabled: props.meta.currentPage === props.meta.lastPage })
  ] });
}
function ListView(props) {
  const [Page, setPage] = useState(1);
  const [Payloads, setPayloads] = useState();
  useEffect(() => {
    getItems();
  }, [Page, props.reload]);
  async function getItems() {
    const payloads = await props.getItems({ page: Page });
    if (!payloads)
      return;
    setPayloads({ ...{}, ...payloads });
  }
  if (!Payloads)
    return /* @__PURE__ */ jsxRuntimeExports.jsx(jsxRuntimeExports.Fragment, {});
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(jsxRuntimeExports.Fragment, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: "mb-2", children: [
      Payloads.meta.length,
      "件中",
      Payloads.meta.getLength,
      "件表示中"
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(props.itemWrapper, { children: Payloads.items.map(props.itemCallback) }),
    /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "mt-2", children: /* @__PURE__ */ jsxRuntimeExports.jsx(Paginate, { meta: Payloads.meta, setPage }) })
  ] });
}
function PageWrapper(props) {
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx("h3", { children: props.title }),
    props.breadCrumb && /* @__PURE__ */ jsxRuntimeExports.jsxs(Breadcrumb, { className: "my-2", children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx(Breadcrumb.Item, { href: "/", children: "HOME" }),
      props.breadCrumb.map(
        (item) => /* @__PURE__ */ jsxRuntimeExports.jsx(BreadcrumbItem, { item, navigate: props.breadCrumbOnClick }, item.text)
      ),
      /* @__PURE__ */ jsxRuntimeExports.jsx(Breadcrumb.Item, { active: true, children: props.title })
    ] }),
    props.children
  ] });
}
function BreadcrumbItem(props) {
  function onClick(e) {
    if (!props.navigate)
      return;
    props.navigate(e, props.item);
  }
  return /* @__PURE__ */ jsxRuntimeExports.jsx(Breadcrumb.Item, { href: props.item.link, onClick, children: props.item.text });
}
function Popup({ header, footer, children, ...props }) {
  return /* @__PURE__ */ jsxRuntimeExports.jsxs(Modal, { animation: true, scrollable: true, centered: true, ...props, children: [
    header && /* @__PURE__ */ jsxRuntimeExports.jsx(Modal.Header, { closeButton: true, children: header }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(Modal.Body, { children }),
    footer && /* @__PURE__ */ jsxRuntimeExports.jsx(Modal.Footer, { children: footer })
  ] });
}
export {
  Anchor,
  ListView,
  PageWrapper,
  Paginate,
  Popup
};
